program KeyboardInput;

{$mode objfpc}{$H+}

{Declare some units used by this example.}
uses
  GlobalConst,
  GlobalTypes,
  Platform,
  Threads,
  Console,
  Framebuffer,
  BCM2835,
  BCM2708,
  SysUtils,
  Keyboard, {Keyboard uses USB so that will be included automatically}
  DWCOTG;   {We need to include the USB host driver for the Raspberry Pi}

{We'll need a window handle again.}
var
 WindowHandle:TWindowHandle;
 one_Byte : Byte;





function KeyRead : Byte;
var
 Count:LongWord;
 KeyboardData:TKeyboardData;
 Character : Byte;
begin

 Character:=0;

 if KeyboardRead(@KeyboardData,SizeOf(KeyboardData),Count) = ERROR_SUCCESS then
  begin

    Character:=KeyboardData.KeyCode;

    // Ctrl
    if KeyboardData.Modifiers=1 then begin
      // a..z
      if (KeyboardData.KeyCode>=$61) and (KeyboardData.KeyCode<=$7A) then begin
        // then -> ^A .. ^Z (01H..1AH)
        Character:=KeyboardData.KeyCode-$60;
      end;
    end;

  end;

   Result:=Character;

end; { function KeyRead }





begin
 {Create a console window at full size}
 WindowHandle:=ConsoleWindowCreate(ConsoleDeviceGetDefault,CONSOLE_POSITION_FULL,True);

 {Output some welcome text on the console window}
 ConsoleWindowWriteLn(WindowHandle,'Welcome to Example 04 Keyboard Input');
 ConsoleWindowWriteLn(WindowHandle,'Make sure you have a USB keyboard connected and start typing some characters');


 while true do begin

   one_Byte:=KeyRead;
   WriteLn('KeyRead= ' + IntToHex(one_Byte,2)+' '+Char(one_Byte));

 end;



end.

